//Driver Station map
//Values may change frequently
#ifndef DSMAP_H
#define DSMAP_H

//Joystick Ports
#define DS_JOY_PORT_LEFT 1
#define DS_JOY_PORT_RIGHT 2
#define DS_JOY_PORT_EMULATED 3

//Joystick Buttons
#define DS_JOYBTN_TURBO 1
#define DS_JOYBTN_SLOW 2
#define DS_JOYBTN_WINGS 3
#define DS_JOYBTN_WINGS_DOWN 4
#define DS_JOYBTN_WINGS_UP 5
#define DS_JOYBTN_DEBUG_DRIVETRAIN 6
#define DS_JOYBTN_DEBUG_SHOOTER 7
#define DS_JOYBTN_DEBUG_STORAGE 8
#define DS_JOYBTN_DEBUG_TURRET 9
#define DS_JOYBTN_SHOW_POS 10
#define DS_JOYBTN_NEXT_PATTERN 11

//Emulated Joystick Inputs
//Digital Buttons
#define DS_BROKEN_BRIDGE 1
#define DS_BROKEN_TURRET_ANGLE 2
#define DS_BROKEN_SHOOTER_SPEED 3
#define DS_BROKEN_SMART_SHOOTER 4
#define DS_BROKEN_CONVEYOR 5
#define DS_CONTINUOUS_SHOOTER 6
#define DS_ENABLE_BACKSPIN 7
#define DS_REQUEST_COOPERTITION 8
#define DS_BALL_COLLECT_DOWN 9
#define DS_BALL_COLLECT_UP 10
#define DS_SHOOT_HEIGHT_HIGH 11
#define DS_SHOOT_HEIGHT_LOW 12	
//Analog Axis
#define DS_TURRET_ANGLE 1
#define DS_SHOOTER_POWER 2
#define DS_DEBUG_DIAL1 3
#define DS_CAMTILT_DIAL 4
#define DS_DIGITAL1 5		//Includes automode startpos and steps
#define DS_DIGITAL2 6		//includes automode delay and digital buttons fire and auto aim

//Analog Bits - Channel 5
#define DS_AUTOMODE_START_POS 0x06
#define DS_AUTOMODE_STEPS 0x78

//Analog Bits - Channel 6
#define DS_AUTOMODE_DELAY 0x1E 
#define DS_FIRE 0x20
#define DS_AUTO_AIM 0x40


#endif //DSMAP_H
