#ifndef THUNDER_AUTO
#define THUNDER_AUTO

#include "WPIlib.h"
#include "ThunderDrive.h"
#include "Storage.h"
#include "Smartshooter.h"
#include "Shooter.h"


class ThunderAuto
{
public:
	ThunderAuto(ThunderDrive *drive, SmartShooter *shooter, Storage *storage);
	~ThunderAuto();
	
	// initialize auto (call it once)
	void InitializeAuto(int position, int steps, int delay);
	 
	// process all auto steps (call it for every loop in autonomous)
	bool ProcessAuto();
	
	//Initialize the position one state machine
	void InitializePosition_one();
	
	//Initialize the position two state machine
	void InitializePosition_two();
	
private:
	double begin_time;
	double begin_time_shoot;
	float delayTime;
	
	typedef enum {delay, delay_check, inshoot_one, inshoot_check, inauto_check, finishin} Initial;
	
	//the Autonomous shooting process
	bool Autoshots();	
	
	// updates what the max and min angles will be depending on what your desired angle is
	void updateAngle(float desiredAngle);

	// stops everything!
	void endAuto(bool good_boy);
	
	// for robops, 1 = start position 1, 2 = start position 2, 3 = start position 3, 4 = at the cooperation bridge, 5 = at our alliance's bridge
	// initialize autonomous shooter
	void Initialize_Shooter(int max_balls, bool ask_robot_has_balls, int wait_time, int cam_angle, int tur_angle, double tur_speed_top, double tur_speed_bottom);
	
	//What to do if we are in position one
	bool Position_one ();
	
		
	//What to do if we are in position two.
	bool Position_two ();

	//Position three actions. 
	bool Position_three ();
	
	//1507
	bool Process1507();
	typedef enum { t1507_delay, t1507_ball1, t1507_ball2, t1507_done}Position_1507_States;
	Position_1507_States pos1507_state;
	//1507
	
	
	typedef enum {one_drive_one, one_drive_one_check, one_lower_actuator_check, one_shoot_two_check, one_bridge_check,
	one_done}Position_One_States;
	
	typedef enum {shoot_check_two, two_arc_drive, two_arc_drive_check, two_reverse_arc,
		two_reverse_arc_check, two_shoot_two, two_shoot_two_check, two_bridge, two_bridge_check, two_done, two_error}Positon_Two_States;
	
	typedef enum {Camturn_check, ball_check, shoot_check_wait, shoot_check, finish}Autoshots_States; 
	
	// checks if we are off course
	bool checkCourse();
	
	
	Position_One_States posone_state;
	Positon_Two_States postwo_state;
	Autoshots_States autoshot_state;
	Initial initial_state;	
	
	int Max_Balls;
	int Ask_Robot_Has_Balls;
	int Wait_Time;
	int Robopos;
	int Step_Count;
	int Delay_Time;
	bool Moving_Wings;
	
	
	SmartShooter*Thundershootercode;
	Storage*Thunderstorage;
	ThunderDrive*ThunderDriveCode;
	
	//to make sure we are still driving on course.
	float minAngle;					// min angle we need to stay within
	float maxAngle;					// max angle we need to stay within


};
#endif 
